local Dungeons = LibStub('AceAddon-3.0'):GetAddon('BestInSlotRedux'):NewModule('ShadowlandsDungeons')
local dungeonTierId = 90002
local tocVersion = select(1, GetBuildInfo())
local bonusIds_WoD = {
	bonusids = {
		[1] = {3183,8270,7359,6646},
		[2] = {3189,6536,6646},--M+ Casino
	},
	difficultyconversion = {
		[1] = 35, -- Mythic+
		[2] = 8, -- Great Vault
	},
}
local bonusIds_Legion = {
	bonusids = {
		[1] = {3177,8270,7359,6646},
		[2] = {3183,6536,6646},--M+ Casino
	},
	difficultyconversion = {
		[1] = 35, -- Mythic+
		[2] = 8, -- Great Vault/
	},
}
local bonusIds_BfA = {
	bonusids = {
		[1] = {3149,8270,7359,6646},
		[2] = {3155,6536,6646},--M+ Casino
	},
	difficultyconversion = {
		[1] = 35, -- Mythic+
		[2] = 8, -- Great Vault
	},
}
local bonusIds_SL = {
	bonusids = {
		[1] = {1615,8270,7359,6646},
		[2] = {1621,6536,6646},--M+ Casino
	},
	difficultyconversion = {
		[1] = 35, -- Mythic+
		[2] = 8, -- Great Vault
	},
}

--------------------------------------------------
----- Operation: Mechagon
--------------------------------------------------
function Dungeons:OperationMechagon()
	local operationMechagon = 'operationMechagon'
	local name = C_Map.GetMapInfo(1490).name
	self:RegisterRaidInstance(dungeonTierId , operationMechagon, name, bonusIds_BfA)


	--------------------------------------------------
	----- King Gobbamak
	--------------------------------------------------
	local bossName = EJ_GetEncounterInfo(2357)
	local lootTable = {
		169035, --Reclaimed Shock Coil
		169053, --Roughshod Chain Boots
		169054, --Galvanized Leather Grips
		169049, --Supplicant's Soiled Slippers
		169050, --Logg
		169051, --Anodized Plate Legguards
		169052, --Cranial Recalibrator
		170507, --Omnipurpose Logic Board
	}
	self:RegisterBossLoot(operationMechagon, lootTable, bossName)


	--------------------------------------------------
	----- Gunker
	--------------------------------------------------
	local bossName = EJ_GetEncounterInfo(2358)
	local lootTable = {
		169055, --Greaves of Acid Resistance
		169057, --Well-Oiled Plate Girdle
		169059, --Slick Tactical Grips
		169062, --Sharpened Trogg Femur
		169058, --Salvaged Incendiary Tool
		169056, --Ooey-Gooey Galoshes
		169060, --Mekgineer's Utility Belt
		169061, --Insulating Threaded Gloves
		170508, --Optimized Logic Board
	}
	self:RegisterBossLoot(operationMechagon, lootTable, bossName)


	--------------------------------------------------
	----- Trixie & Naeno
	--------------------------------------------------
	local bossName = EJ_GetEncounterInfo(2360)
	local lootTable = {
		169066, --Trixie's Backup Backbiter
		169069, --Wraps of Electrostatic Potential
		169067, --Silken Safety Harness
		169068, --Salvaged Mekacycle Shielding
		169064, --Mountebank's Colorful Cloak
		169070, --Unseen Predator's Breeches
		169063, --High Speed Gauntlets
		169065, --Reinforced Riding Chausses
		169769, --Remote Guidance Device
		170509, --Performant Logic Board
	}
	self:RegisterBossLoot(operationMechagon, lootTable, bossName)


	--------------------------------------------------
	----- HK-8 Aerial Oppression Unit
	--------------------------------------------------
	local bossName = EJ_GetEncounterInfo(2355)
	local lootTable = {
--		169075, --Tank Buster Pauldrons
		169077, --Light Auto-Stabilizing Energy Rifle
		169071, --Overcharged Pantaloons
--		169072, --Volatile Arming Doublet
--		169074, --Epaulettes of Arcing Power
--		169073, --Type II Bomber Jacket
		168826, --Mechagon Peacekeeper
		169156, --Logic Loop of Synergy
		169076, --Logic Loop of Maintenance
		169157, --Logic Loop of Division
		169158, --Logic Loop of Recursion
		168909, --Subroutine: Emergency Repairs
		167677, --Harmonic Dematerializer
		168657, --Friend-or-Foe Identifier
		168963, --Fusion Hacker
		169385, --Microbot 8D
		170510, --Forceful Logic Board
	}
	self:RegisterBossLoot(operationMechagon, lootTable, bossName)


	--------------------------------------------------
	----- Tussle Tonks
	--------------------------------------------------
	local bossName = EJ_GetEncounterInfo(2336)
	local lootTable = {
		168958, --Ringmaster's Cummerbund
		168965, --Modular Platinum Plating
		168964, --Hyperthread Boots
		168962, --Apex Perforator
		168966, --Heavy Alloy Legplates
		168957, --Mekgineer's Championship Belt
		168955, --Electrifying Cognitive Amplifier
		168967, --Gold-Coated Superconductors
		170510, --Forceful Logic Board
	}
	self:RegisterBossLoot(operationMechagon, lootTable, bossName)


	--------------------------------------------------
	----- K.U.-J.0.
	--------------------------------------------------
	local bossName = EJ_GetEncounterInfo(2339)
	local lootTable = {
		168969, --Operator's Mitts
		168970, --Trashmaster's Mantle
		168972, --Pyroclastic Greatboots
		168971, --Swift Pneumatic Grips
		168968, --Flame-Seared Leggings
		170508, --Optimized Logic Board
	}
	self:RegisterBossLoot(operationMechagon, lootTable, bossName)


	--------------------------------------------------
	----- Machinist's Garden
	--------------------------------------------------
	local bossName = EJ_GetEncounterInfo(2348)
	local lootTable = {
		168975, --Machinist's Treasured Treads
		168973, --Neural Synapse Enhancer
		168974, --Self-Repairing Cuisses
		168976, --Automatic Waist Tightener
		169159, --Overclocking Bit Band
		169160, --Shorting Bit Band
		168977, --Rebooting Bit Band
		169161, --Protecting Bit Band
		169344, --Ingenious Mana Battery
		169608, --Tearing Sawtooth Blade
		170507, --Omnipurpose Logic Board
		167556, --Subroutine: Overclock
	}
	self:RegisterBossLoot(operationMechagon, lootTable, bossName)


	--------------------------------------------------
	----- King Mechagon
	--------------------------------------------------
	local bossName = EJ_GetEncounterInfo(2331)
	local lootTable = {
		168980, --Gauntlets of Absolute Authority
		168986, --Mad King's Sporran
		168983, --Maniacal Monarch's Girdle
		168985, --Self-Sanitizing Handwraps
		168989, --Hyperthread Wristwraps
		168988, --Royal Attendant's Trousers
--		168984, --Extravagant Epaulettes
		168982, --Regal Mekanospurs
--		168987, --Shoulderguards of Fraying Sanity
--		168981, --Circuit-Linked Chainmail
--		168979, --Mechanized Plate Chasse
		168978, --Anodized Deflectors
		168671, --Electromagnetic Resistors
		169378, --Golden Snorf
		169774, --Progression Sprocket
		168842, --Engine of Mecha-Perfection
		169172, --Blueprint: Perfectly Timed Differential
		170509, --Performant Logic Board
	}
	self:RegisterBossLoot(operationMechagon, lootTable, bossName)
end

--------------------------------------------------
----- Tazavesh, the Veiled Market
--------------------------------------------------
function Dungeons:TazaveshtheVeiledMarket()
	local tazaveshtheveiledmarket = "tazaveshtheveiledmarket"
	local name = C_Map.GetMapInfo(1990).name
	self:RegisterRaidInstance(dungeonTierId, tazaveshtheveiledmarket, name, bonusIds_SL)



	-----------------------------------
	----- Zo'phex the Sentinel
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(2437)
	local lootTable = {
		183468, --Born Anew
		183498, --Cloaked in Shadows
		182110, --Crippling Hex
		182330, --Demonic Parole
		181962, --Mental Recovery
		182338, --Pure Concentration
		181841, --Reinforced Shell
		185824, --Blade of Grievous Harm
		185780, --Interrogator's Flensing Blade
		185816, --Confiscated Bracers of Concealment
		185815, --Vambraces of Verification
		185793, --Cyphered Gloves
		185791, --Knuckle-Dusting Handwraps
	}
	self:RegisterBossLoot(tazaveshtheveiledmarket, lootTable, bossName)


	-----------------------------------
	----- The Grand Menagerie
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(2454)
	local lootTable = {
		184587, --Ambuscade
		181512, --Dizzying Tumble
		181756, --Incantation of Swiftness
		181469, --Indelible Victory
		183044, --Kilrogg's Cunning
		181836, --Spirit Drain
		185777, --Fang of Alcruux
		185821, --Gluttonous Rondel
		185814, --Auctioneer's Counting Bracers
		185792, --Achillite's Unbreakable Grip
		185794, --Gavel Pounders
		185809, --Venza's Powderbelt
		185840, --Seal of the Panoply
	}
	self:RegisterBossLoot(tazaveshtheveiledmarket, lootTable, bossName)


	-----------------------------------
	----- Mailroom Mayhem
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(2436)
	local lootTable = {
		182584, --Cheetah's Vigor
		181837, --Clear Mind
		182461, --Echoing Blessings
		186534, --Gizmo
		182325, --Ravenous Consumption
		183497, --Recuperator
		183465, --Ursine Vigor
		185811, --Package Protector
		185817, --Bracers of Autonomous Classification
		185808, --Discount Mail-Order Belt
		185807, --Pan-Dimensional Packing Cord
		185787, --Implacable Weatherproof Treads
		185845, --First Class Healing Distributor
		185846, --Miniscule Mailemental in an Envelope
		185844, --Ticking Sack of Terror
	}
	self:RegisterBossLoot(tazaveshtheveiledmarket, lootTable, bossName)


	-----------------------------------
	----- Myza's Oasis
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(2452)
	local lootTable = {
		182460, --Accrued Vitality
		183470, --Born of the Wilds
		182656, --Disturb the Peace
		181508, --Fortifying Ingredients
		182106, --Refreshing Waters
		181464, --Winter's Protection
		185783, --Yasahm the Riftbreaker
		185812, --Acoustically Alluring Censer
		185842, --Ornately Engraved Amplifier
		185802, --Breakbeat Shoulderguards
		185804, --Harmonious Spaulders
		185806, --Improvisational Cinch
		185789, --Sabatons of Measured Time
	}
	self:RegisterBossLoot(tazaveshtheveiledmarket, lootTable, bossName)


	-----------------------------------
	----- So'azmi
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(2451)
	local lootTable = {
		181707, --Diverted Energy
		182449, --Resolute Barrier
		182605, --Tactical Retreat
		181826, --Translucent Image
		182132, --Unending Grip
		182318, --Viscous Ink
		185778, --First Fist of the So Cartel
		185843, --Duplicating Drape
		185782, --Robes of Midnight Bargains
		185786, --So'azmi's Fractal Vest
		185800, --Orbitwarp Culottes
		185798, --Quantum Leapers
		185836, --Codex of the First Technique
	}
	self:RegisterBossLoot(tazaveshtheveiledmarket, lootTable, bossName)


	-----------------------------------
	----- Hylbrande
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(2448)
	local lootTable = {
		182105, --Astral Protection
		180943, --Cacophonous Roar
		182336, --Golden Path
		181373, --Harm Denial
		183501, --Rushed Setup
		183467, --Tireless Pursuit
		185810, --Skyreaver, Greataxe of the Keepers
		185779, --Spire of Expurgation
		185805, --Hylbrande's Retrofitted Shoulderguards
		185803, --Stoneflesh Spaulders
		185781, --Drape of Titanic Dreams
		185788, --Codebreaker's Cunning Sandals
		185790, --Treads of Titanic Deconversion
	}
	self:RegisterBossLoot(tazaveshtheveiledmarket, lootTable, bossName)


	-----------------------------------
	----- Timecap'n Hooktail
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(2449)
	local lootTable = {
		181498, --Grounding Surge
		181975, --Hardened Bones
		183502, --Prepared for All
		182469, --Rejuvenating Wind
		182466, --Shade of Terror
		180842, --Stalwart Guardian
		185823, --Fatebreaker, Destroyer of Futures
		185841, --Timetwister Tulwar
		185795, --Cowl of Branching Fate
		185796, --Dragonbane Diadem
		185776, --Hooktail's Commanding Gaze
		185797, --Rakishly Tipped Tricorne
		185820, --Cabochon of the Infinite Flight
	}
	self:RegisterBossLoot(tazaveshtheveiledmarket, lootTable, bossName)


	-----------------------------------
	----- So'leah
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(2455)
	local lootTable = {
		186638, --Cartel Master's Gearglider Mount
		181838, --Charitable Soul
		182304, --Divine Call
		182316, --Fel Defender
		183466, --Innate Resolve
		181510, --Lingering Numbness
		182480, --Reversal of Fortune
		182109, --Totemic Surge
		185822, --Staff of Fractured Spacetime
		185819, --Event Horizon's Edge
		185785, --Embrace of the Relicbinder
		185784, --Novaburst Warplate
		185801, --Anomalous Starlit Breeches
		185799, --Hyperlight Leggings
		185813, --Signet of Collapsing Stars
		185818, --So'leah's Secret Technique
	}
	self:RegisterBossLoot(tazaveshtheveiledmarket, lootTable, bossName)
end

--------------------------------------------------
----- Return to Karazhan
--------------------------------------------------
function Dungeons:ReturnToKarazhan()
	local RtK = "RtK"
	--local name1 = GetMapNameByID(1651) -- Lower
	--local name2 = GetMapNameByID(1651) -- Upper
	--local name3 = GetMapNameByID(1115) -- Normal / Old (need real ID -.- )
	local name3 = C_Map.GetMapInfo(814).name
	self:RegisterRaidInstance(dungeonTierId, RtK, name3, bonusIds_Legion)

	-----------------------------------
	----- Opera Beast
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(1827)
	local lootTable = {
		142206, -- Cloak of Sweltering Flame
		142184, -- Candle of Flickering Lumens
		142192, -- Ghastly Curse
		142188, -- Spellbound Rose Petal
		142202, -- Trousers of Royal Vanity
		142196, -- Cinch of Improbable Desire
		142304, -- Visage of Brutish Iron
		142197, -- Legguards of Imprisonment
		142168, -- Majordomo's Dinner Bell
	}
	self:RegisterBossLoot(RtK, lootTable, bossName)

	-----------------------------------
	----- Opera Wicket
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(1820)
	local lootTable = {
		142175, -- Arcanum of Weightlessness
		142298, -- Astonishingly Scarlet Slippers
		142204, -- Boots of False Promises
		142194, -- Gloomy Vortex
		142300, -- Greaves of Miraculous Magnificence
		142299, -- Horkin' Stuff-Lobbers
		142198, -- Inordinately Wonderous Wristguards
		142205, -- Jabber Grookin' Gauntlets
		142179, -- Memory of Betrayal
		142137, -- Short Jibbet Waistguard
		142296, -- Wikket Witch's Hat
	}
	self:RegisterBossLoot(RtK, lootTable, bossName)

	-----------------------------------
	----- Opera Westfall
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(1826)
	local lootTable = {
		142302, -- Armguards of Burning Passion
		142146, -- Blackfin Wristband
		142154, -- Bracelets of the Sorrowful Bride
		142190, -- Love's Intermission
		142201, -- Mantle of Conflicted Loyalties
		142160, -- Mrrgria's Favor
		142186, -- Mrrmgmrl Grmmlmglrg
		142178, -- Ruffian's Poisoned Blade
		142164, -- Toe Knee's Promise
	}
	self:RegisterBossLoot(RtK, lootTable, bossName)

	-----------------------------------
	----- Maiden
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(1825)
	local lootTable = {
		142170, -- Drape of Shame
		142124, -- Treads of the Depraved
		142193, -- Begrudging Confessions
		142139, -- Vest of Wanton Deeds
		142153, -- Cord of the Penitent
		142187, -- Virtuous Directive
		142158, -- Faith's Crucible
		142138, -- Confiscated Manacles
	}
	self:RegisterBossLoot(RtK, lootTable, bossName)

	-----------------------------------
	----- Moroes
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(1837)
	local lootTable = {    
		142171, -- Seal of Darkshire Nobility
		142123, -- Breastplate of Obligation
		142147, -- Robes of Wicked Modesty
		142159, -- Bloodstained Handkerchief
		142134, -- Castellan's Blinders
		142189, -- Perfectly Preserved Apple
		142143, -- Willbreaker Legguards
		142177, -- Jagged Emerald
	}
	self:RegisterBossLoot(RtK, lootTable, bossName)

	-----------------------------------
	----- Huntsman
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(1835)
	local lootTable = {
		142140, -- Calliard's Galoshes
		142174, -- Choker of Barbed Reins
		142191, -- Dirge of the Hunted
		142185, -- Fear of Predation
		142126, -- Helm of Phantasmal Scars
		142161, -- Inescapable Dread
		142183, -- Lava-Quenched Hoofplate
		142136, -- Mantle of Hideous Trophies
		142148, -- Wilderness Stalker's Softsoles
	}
	self:RegisterBossLoot(RtK, lootTable, bossName)

	-----------------------------------
	----- Curator 
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(1836)
	local lootTable = {
		142172, --Terestian's Signet Ring
		142130, --Bite-Marked Wristplates
		142165, --Deteriorated Construct Core
		142125, --Repurposed Golem Grips
		142149, --Gloves of Arcane Confluence
		142309, --Fauna Analysis Widget
		142133, --Gauntlets of Confinement
		142141, --Custodian's Soothing Touch
		142176, --Arcing Static Charge
		142181, --Seeping Corruption
	}
	self:RegisterBossLoot(RtK, lootTable, bossName)

	-----------------------------------
	----- Medivh
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(1817)
	local lootTable = {
		142207, -- Amulet of the Last Guardian
		142157, -- Aran's Relaxing Ruby
		142152, -- Shoulderpads of Chaotic Thought
		142129, -- Spellwarding Waistguard
		142310, -- Anthology of Horrors
		142131, -- Frozen-Link Chestguard
		142145, -- Girdle of Ghostly Exclusion
		142169, -- Raven Eidolon
		142308, -- Ageless Winter
	}
	self:RegisterBossLoot(RtK, lootTable, bossName)

	-----------------------------------
	----- Mana Devourer
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(1818)
	local lootTable = {
		142162, -- Fluctuating Energy
		142180, -- Grisly Schism
		142150, -- Hood of Uncanny Perspectives
		142135, -- Legguards of Countless Hours
		142307, -- Miniature Bonfire
		142128, -- Pauldrons of Encroaching Limits
		142305, -- Suffused Manapearl
		142144, -- Unending Horizon Spaulders
		142215, -- Wine-Stained Mantle
	}
	self:RegisterBossLoot(RtK, lootTable, bossName)

	-----------------------------------
	----- Vizaduum
	-----------------------------------
	local bossName = EJ_GetEncounterInfo(1838)
	local lootTable = {
		142173, -- Ring of Collapsing Futures
		142167, -- Eye of Command
		142306, -- Rift Stabilization Shard
		142132, -- Doomstride Footguards
		142142, -- Unbound Reality Mask
		142151, -- Leggings of Countless Worlds
		142127, -- Tassets of Perpetual Despair
		142182, -- Viz'aduum's Mindstone
	}
	self:RegisterBossLoot(RtK, lootTable, bossName)
end

--------------------------------------------------
----- Grimrail Depot
--------------------------------------------------
function Dungeons:GrimrailDepot()
	local grimraildepot = 'grimraildepot'
	local name = C_Map.GetMapInfo(606).name
	self:RegisterRaidInstance(dungeonTierId , grimraildepot, name, bonusIds_WoD)
	
	-----------------------------------
	----- Rocketspark and Borka
	-----------------------------------	
	local bossName = EJ_GetEncounterInfo(1138) 
	local lootTable = { 
		110051, --Overseer's Final Word 
		109829, --Belt of Burning Focus 
		109842, --Blackwater Belt 
		109830, --Bloodfeather Girdle 
		109824, --Cord of Arcane Mystery 
		109826, --Cord of Swirling Light 
		109831, --Crystalbinder Belt 
		109828, --Felflame Belt 
		109825, --Frost-Touched Cord 
		109839, --Goldsteel Belt 
		109840, --Gutcrusher Greatbelt 
		109837, --Incarnadine Girdle 
		109836, --Lavalink Girdle 
		109832, --Leafmender Girdle 
		109827, --Lightbinder Girdle 
		109843, --Morningscale Waistguard 
		109841, --Rivet-Sealed Waistplate 
		109835, --Rockhide Links 
		109834, --Sharpeye Belt 
		109833, --Streamslither Belt 
		109838, --Verdant Plate Belt 
		109779, --Ancient Draenic Loop 
		109768, --Band of Growing Leaves 
		109773, --Band of Iron Scale 
		109783, --Band of the Stalwart Stanchion 
		109775, --Bladebinder Ring 
		109771, --Bloodied Ring of Mytosis 
		109761, --Bloodthorn Band 
		109760, --Ced's Chiming Circle 
		109766, --Darkflame Loop 
		109763, --Diamondglow Circle 
		109782, --Disease-Binder Seal 
		109765, --Golem's Gleaming Eye 
		109772, --Knucklebone of Lo'Dronar 
		109764, --Mark of Ice 
		109767, --Ring of Purified Light 
		109774, --Ring of Ripped Flesh 
		109759, --Ro-Ger's Brown Diamond Seal 
		109776, --Seal of Resilient Fortitude 
		109781, --Seal of Vindication 
		109770, --Signet of Crashing Waves 
		109762, --Signet of Radiant Leaves 
		109780, --Signet of Shifting Magics 
		109778, --Signet of the Glorious Protector 
		109769, --Slicebinder Loop 
		109777, --Unsullied Signet 
	} 
	self:RegisterBossLoot(grimraildepot, lootTable, bossName)

	-----------------------------------
	----- Nitrogg Thundertower
	-----------------------------------		
	local bossName = EJ_GetEncounterInfo(1163) 
	local lootTable = { 
		110052, --Scepter of Brutality 
		109957, --Alc's Pendant of Fiery Dreams 
		109962, --Bloodmist Pendant 
		109959, --Chain of Soothing Light 
		109969, --Choker of Weeping Viscera 
		109955, --Demonbinder Cabochon 
		109951, --Fireblade Collar 
		109965, --Fistbreak Choker 
		109968, --Flesh Beetle Brooch 
		109963, --Goreclasp Choker 
		109958, --Healing Leaf Necklace 
		109954, --Magister's Chain 
		109956, --Necklace of Endless Shadow 
		109964, --Necklace of Furious Zeal 
		109967, --Necklace of Holy Deflection 
		109961, --Pendant of Purifying Mists 
		109966, --Reinforced Bloodsteel Gorget 
		109952, --Skulltooth Chain 
		109950, --Stormshot Choker 
		109960, --Wavesurge Choker 
		109953, --Windseal Necklace 
		109898, --Blackwater Wrap 
		109885, --Bloodfeather Chestwrap 
		109884, --Chestguard of Burning Focus 
		109886, --Crystalbinder Chestguard 
		109903, --Felflame Robes 
		109900, --Frost-Touched Robes 
		109894, --Goldsteel Chestguard 
		109895, --Gutcrusher Chestplate 
		109892, --Incarnadine Breastplate 
		109890, --Lavalink Ringmail 
		109897, --Leafmender Robes 
		109902, --Lightbinder Robes 
		109891, --Morningscale Chestguard 
		109896, --Rivet-Sealed Breastplate 
		109899, --Robes of Arcane Mystery 
		109901, --Robes of Swirling Light 
		109889, --Rockhide Ringmail 
		109888, --Sharpeye Chestguard 
		109887, --Streamslither Chestguard 
		109893, --Verdant Plate Chest 
		109996, --Thundertower's Targeting Reticle 
	} 
	self:RegisterBossLoot(grimraildepot, lootTable, bossName) 

	-----------------------------------
	----- Skylord Tovra
	-----------------------------------	
	local bossName = EJ_GetEncounterInfo(1133) 
	local lootTable = { 
		110054, --Thunderlord Flamestaff 
		110053, --Arrowbreaker Greatshield 
		109882, --Blackwater Wristguards 
		109869, --Bloodfeather Bracers 
		109864, --Bracers of Arcane Mystery 
		109868, --Bracers of Burning Focus 
		109866, --Bracers of Swirling Light 
		109870, --Crystalbinder Wristguards 
		109881, --Felflame Bracers 
		109865, --Frost-Touched Wristwraps 
		109878, --Goldsteel Bindings 
		109879, --Gutcrusher Bracers 
		109876, --Incarnadine Bracers 
		109875, --Lavalink Bracers 
		109871, --Leafmender Wraps 
		109867, --Lightbinder Wristwraps 
		109883, --Morningscale Bracers 
		109880, --Rivet-Sealed Bracers 
		109874, --Rockhide Wristguards 
		109873, --Sharpeye Bracers 
		109872, --Streamslither Bracers 
		109877, --Verdant Plate Wristguards 
		109862, --Blackwater Grips 
		109849, --Bloodfeather Grips 
		109850, --Crystalbinder Gloves 
		109861, --Felflame Grips 
		109845, --Frost-Touched Gloves 
		109848, --Gauntlets of Burning Focus 
		109844, --Gloves of Arcane Mystery 
		109846, --Gloves of Swirling Light 
		109858, --Goldsteel Gloves 
		109859, --Gutcrusher Gauntlets 
		109856, --Incarnadine Gauntlets 
		109855, --Lavalink Grips 
		109851, --Leafmender Grips 
		109847, --Lightbinder Gloves 
		109863, --Morningscale Gauntlet 
		109860, --Rivet-Sealed Crushers 
		109854, --Rockhide Gloves 
		109853, --Sharpeye Gauntlets 
		109852, --Streamslither Gauntlets 
		109857, --Verdant Plate Grips 
		109823, --Blackwater Leggings 
		109810, --Bloodfeather Leggings 
		109811, --Crystalbinder Legwraps 
		109808, --Felflame Legwraps 
		109805, --Frost-Touched Legwraps 
		109820, --Goldsteel Legplates 
		109821, --Gutcrusher Legplates 
		109818, --Incarnadine Legplates 
		109816, --Lavalink Legguards 
		109812, --Leafmender Legwraps 
		109806, --Leggings of Swirling Light 
		109809, --Legguards of Burning Focus 
		109807, --Lightbinder Leggings 
		109817, --Morningscale Leggings 
		109822, --Rivet-Sealed Legplates 
		109815, --Rockhide Leggings 
		109814, --Sharpeye Legguards 
		109813, --Streamslither Legguards 
		109804, --Trousers of Arcane Mystery 
		109819, --Verdant Plate Legguards 
		110001, --Tovra's Lightning Repository 
	} 
	self:RegisterBossLoot(grimraildepot, lootTable, bossName)
end


--------------------------------------------------
----- Iron Docks
--------------------------------------------------
function Dungeons:IronDocks()
	local irondocks = 'irondocks'
	local name = C_Map.GetMapInfo(595).name
	self:RegisterRaidInstance(dungeonTierId , irondocks, name, bonusIds_WoD)
	
	-----------------------------------
	----- Fleshrender Nok'gar
	-----------------------------------	
		local bossName = EJ_GetEncounterInfo(1235) 
		local lootTable = { 
		110055, --Gutwrench Goreaxe 
		109898, --Blackwater Wrap 
		109885, --Bloodfeather Chestwrap 
		109884, --Chestguard of Burning Focus 
		109886, --Crystalbinder Chestguard 
		109903, --Felflame Robes 
		109900, --Frost-Touched Robes 
		109894, --Goldsteel Chestguard 
		109895, --Gutcrusher Chestplate 
		109892, --Incarnadine Breastplate 
		109890, --Lavalink Ringmail 
		109897, --Leafmender Robes 
		109902, --Lightbinder Robes 
		109891, --Morningscale Chestguard 
		109896, --Rivet-Sealed Breastplate 
		109899, --Robes of Arcane Mystery 
		109901, --Robes of Swirling Light 
		109889, --Rockhide Ringmail 
		109888, --Sharpeye Chestguard 
		109887, --Streamslither Chestguard 
		109893, --Verdant Plate Chest 
		109779, --Ancient Draenic Loop 
		109768, --Band of Growing Leaves 
		109773, --Band of Iron Scale 
		109783, --Band of the Stalwart Stanchion 
		109775, --Bladebinder Ring 
		109771, --Bloodied Ring of Mytosis 
		109761, --Bloodthorn Band 
		109760, --Ced's Chiming Circle 
		109766, --Darkflame Loop 
		109763, --Diamondglow Circle 
		109782, --Disease-Binder Seal 
		109765, --Golem's Gleaming Eye 
		109772, --Knucklebone of Lo'Dronar 
		109764, --Mark of Ice 
		109767, --Ring of Purified Light 
		109774, --Ring of Ripped Flesh 
		109759, --Ro-Ger's Brown Diamond Seal 
		109776, --Seal of Resilient Fortitude 
		109781, --Seal of Vindication 
		109770, --Signet of Crashing Waves 
		109762, --Signet of Radiant Leaves 
		109780, --Signet of Shifting Magics 
		109778, --Signet of the Glorious Protector 
		109769, --Slicebinder Loop 
		109777, --Unsullied Signet 
		110002, --Fleshrender's Meathook 
		} 
		self:RegisterBossLoot(irondocks, lootTable, bossName)
	-----------------------------------
	----- Grimrail Enforvers
	-----------------------------------		
		local bossName = EJ_GetEncounterInfo(1236) 
		local lootTable = { 
		110056, --Black Iron Sniper Rifle 
		109979, --Blackwater Helm 
		109976, --Bloodfeather Cowl 
		109977, --Crystalbinder Helm 
		109974, --Felflame Hood 
		109971, --Frost-Touched Hood 
		109987, --Goldsteel Greathelm 
		109988, --Gutcrusher Coronet 
		109970, --Hood of Arcane Mystery 
		109975, --Hood of Burning Focus 
		109972, --Hood of Swirling Light 
		109985, --Incarnadine Greathelm 
		109983, --Lavalink Helm 
		109978, --Leafmender Hood 
		109973, --Lightbinder Cover 
		109984, --Morningscale Cowl 
		109989, --Rivet-Sealed Casque 
		109982, --Rockhide Casque 
		109981, --Sharpeye Gleam 
		109980, --Streamslither Helm 
		109986, --Verdant Plate Crown 
		109957, --Alc's Pendant of Fiery Dreams 
		109962, --Bloodmist Pendant 
		109959, --Chain of Soothing Light 
		109969, --Choker of Weeping Viscera 
		109955, --Demonbinder Cabochon 
		109951, --Fireblade Collar 
		109965, --Fistbreak Choker 
		109968, --Flesh Beetle Brooch 
		109963, --Goreclasp Choker 
		109958, --Healing Leaf Necklace 
		109954, --Magister's Chain 
		109956, --Necklace of Endless Shadow 
		109964, --Necklace of Furious Zeal 
		109967, --Necklace of Holy Deflection 
		109961, --Pendant of Purifying Mists 
		109966, --Reinforced Bloodsteel Gorget 
		109952, --Skulltooth Chain 
		109950, --Stormshot Choker 
		109960, --Wavesurge Choker 
		109953, --Windseal Necklace 
		110017, --Enforcer's Stun Grenade 
		} 
		self:RegisterBossLoot(irondocks, lootTable, bossName)
	-----------------------------------
	----- Oshir
	-----------------------------------	
		local bossName = EJ_GetEncounterInfo(1237) 
		local lootTable = { 
		110057, --Mindbreaker Scepter 
		109882, --Blackwater Wristguards 
		109869, --Bloodfeather Bracers 
		109864, --Bracers of Arcane Mystery 
		109868, --Bracers of Burning Focus 
		109866, --Bracers of Swirling Light 
		109870, --Crystalbinder Wristguards 
		109881, --Felflame Bracers 
		109865, --Frost-Touched Wristwraps 
		109878, --Goldsteel Bindings 
		109879, --Gutcrusher Bracers 
		109876, --Incarnadine Bracers 
		109875, --Lavalink Bracers 
		109871, --Leafmender Wraps 
		109867, --Lightbinder Wristwraps 
		109883, --Morningscale Bracers 
		109880, --Rivet-Sealed Bracers 
		109874, --Rockhide Wristguards 
		109873, --Sharpeye Bracers 
		109872, --Streamslither Bracers 
		109877, --Verdant Plate Wristguards 
		109829, --Belt of Burning Focus 
		109842, --Blackwater Belt 
		109830, --Bloodfeather Girdle 
		109824, --Cord of Arcane Mystery 
		109826, --Cord of Swirling Light 
		109831, --Crystalbinder Belt 
		109828, --Felflame Belt 
		109825, --Frost-Touched Cord 
		109839, --Goldsteel Belt 
		109840, --Gutcrusher Greatbelt 
		109837, --Incarnadine Girdle 
		109836, --Lavalink Girdle 
		109832, --Leafmender Girdle 
		109827, --Lightbinder Girdle 
		109843, --Morningscale Waistguard 
		109841, --Rivet-Sealed Waistplate 
		109835, --Rockhide Links 
		109834, --Sharpeye Belt 
		109833, --Streamslither Belt 
		109838, --Verdant Plate Belt 
		109997, --Kihra's Adrenaline Injector 
		} 
		self:RegisterBossLoot(irondocks, lootTable, bossName)
	-----------------------------------
	----- Skulloc
	-----------------------------------	
		local bossName = EJ_GetEncounterInfo(1238) 
		local lootTable = { 
		110059, --Chasmwrench Docking Hook 
		110058, --Bloodied Hand of Woe 
		110060, --Painbringer's Crystal 
		109938, --Blackwater Spaulders 
		109935, --Bloodfeather Spaulders 
		109936, --Crystalbinder Shoulderpads 
		109948, --Felflame Spaulders 
		109931, --Frost-Touched Shoulderpads 
		109945, --Goldsteel Shouldercaps 
		109946, --Gutcrusher Shoulderplates 
		109943, --Incarnadine Shoulderguard 
		109942, --Lavalink Spaulders 
		109937, --Leafmender Mantle 
		109933, --Lightbinder Shoulderpads 
		109930, --Mantle of Arcane Mystery 
		109932, --Mantle of Swirling Light 
		109949, --Morningscale Spaulders 
		109947, --Rivet-Sealed Shoulderplates 
		109941, --Rockhide Shoulderguards 
		109940, --Sharpeye Shoulderguards 
		109934, --Spaulders of Burning Focus 
		109939, --Streamslither Spaulders 
		109944, --Verdant Plate Spaulders 
		109862, --Blackwater Grips 
		109849, --Bloodfeather Grips 
		109850, --Crystalbinder Gloves 
		109861, --Felflame Grips 
		109845, --Frost-Touched Gloves 
		109848, --Gauntlets of Burning Focus 
		109844, --Gloves of Arcane Mystery 
		109846, --Gloves of Swirling Light 
		109858, --Goldsteel Gloves 
		109859, --Gutcrusher Gauntlets 
		109856, --Incarnadine Gauntlets 
		109855, --Lavalink Grips 
		109851, --Leafmender Grips 
		109847, --Lightbinder Gloves 
		109863, --Morningscale Gauntlet 
		109860, --Rivet-Sealed Crushers 
		109854, --Rockhide Gloves 
		109853, --Sharpeye Gauntlets 
		109852, --Streamslither Gauntlets 
		109857, --Verdant Plate Grips 
		109823, --Blackwater Leggings 
		109810, --Bloodfeather Leggings 
		109811, --Crystalbinder Legwraps 
		109808, --Felflame Legwraps 
		109805, --Frost-Touched Legwraps 
		109820, --Goldsteel Legplates 
		109821, --Gutcrusher Legplates 
		109818, --Incarnadine Legplates 
		109816, --Lavalink Legguards 
		109812, --Leafmender Legwraps 
		109806, --Leggings of Swirling Light 
		109809, --Legguards of Burning Focus 
		109807, --Lightbinder Leggings 
		109817, --Morningscale Leggings 
		109822, --Rivet-Sealed Legplates 
		109815, --Rockhide Leggings 
		109814, --Sharpeye Legguards 
		109813, --Streamslither Legguards 
		109804, --Trousers of Arcane Mystery 
		109819, --Verdant Plate Legguards 
		} 
		self:RegisterBossLoot(irondocks, lootTable, bossName)
end


function Dungeons:InitializeZoneDetect(ZoneDetect)
	local operationMechagon = 'operationMechagon'
	ZoneDetect:RegisterMapID(1490, operationMechagon)
	ZoneDetect:RegisterNPCID(150159, operationMechagon, 1) --King Gobbamak
	ZoneDetect:RegisterNPCID(150222, operationMechagon, 2) --Gunker
	ZoneDetect:RegisterNPCID(150712, operationMechagon, 3) --Trixie & Naeno
	ZoneDetect:RegisterNPCID(153755, operationMechagon, 3) --Trixie & Naeno
	ZoneDetect:RegisterNPCID(150190, operationMechagon, 4) --HK-8 Aerial Oppression Unit
	ZoneDetect:RegisterNPCID(144244, operationMechagon, 5) --Tussle Tonks
	ZoneDetect:RegisterNPCID(145185, operationMechagon, 5) --Tussle Tonks
	ZoneDetect:RegisterNPCID(144246, operationMechagon, 6) --K.U.-J.0.
	ZoneDetect:RegisterNPCID(144248, operationMechagon, 7) --Machinist's Garden
	ZoneDetect:RegisterNPCID(154817, operationMechagon, 8) --King Mechagon
	
	local tazaveshtheveiledmarket = "tazaveshtheveiledmarket"
	ZoneDetect:RegisterMapID(1990, tazaveshtheveiledmarket)
	ZoneDetect:RegisterMapID(175616, tazaveshtheveiledmarket, 1)
	ZoneDetect:RegisterNPCID(176556, tazaveshtheveiledmarket, 2)
	ZoneDetect:RegisterNPCID(175646, tazaveshtheveiledmarket, 3)
	ZoneDetect:RegisterNPCID(176564, tazaveshtheveiledmarket, 4)
	ZoneDetect:RegisterNPCID(175806, tazaveshtheveiledmarket, 5)
	ZoneDetect:RegisterNPCID(175663, tazaveshtheveiledmarket, 6)
	ZoneDetect:RegisterNPCID(175546, tazaveshtheveiledmarket, 7)
	ZoneDetect:RegisterNPCID(178433, tazaveshtheveiledmarket, 8)
	
	local RtK = "RtK"
	ZoneDetect:RegisterMapID(1115, RtK)
	ZoneDetect:RegisterNPCID(114328, RtK, 1) -- Opera Beast
	ZoneDetect:RegisterNPCID(114284, RtK, 2) -- Opera Wicket
	ZoneDetect:RegisterNPCID(114261, RtK, 3) -- Opera Westfall
	ZoneDetect:RegisterNPCID(113971, RtK, 4) -- Maiden
	ZoneDetect:RegisterNPCID(114312, RtK, 5) -- Moroes
	ZoneDetect:RegisterNPCID(114262, RtK, 6) -- Huntsman
	ZoneDetect:RegisterNPCID(114247, RtK, 7) -- Curator
	ZoneDetect:RegisterNPCID(114350, RtK, 8) -- Medivh
	ZoneDetect:RegisterNPCID(114252, RtK, 9) -- Mana Devourer
	ZoneDetect:RegisterNPCID(114790, RtK, 10) -- Vizaduum
	
	local grimraildepot = "grimraildepot"
	ZoneDetect:RegisterMapID(606, grimraildepot)
	ZoneDetect:RegisterNPCID(77803, grimraildepot, 1) -- Rocketspark and Borka
	ZoneDetect:RegisterNPCID(77816, grimraildepot, 1) -- Rocketspark and Borka
	ZoneDetect:RegisterNPCID(79545, grimraildepot, 2) -- Nitrogg Thundertower
	ZoneDetect:RegisterNPCID(80005, grimraildepot, 3) -- Skylord Tovra
	
	local irondocks = "irondocks"
	ZoneDetect:RegisterMapID(595, irondocks)
	ZoneDetect:RegisterNPCID(81305, irondocks, 1) -- Fleshrender Nok'gar
	ZoneDetect:RegisterNPCID(80816, irondocks, 2) -- Grimrail Enforvers
	ZoneDetect:RegisterNPCID(80805, irondocks, 2) -- Grimrail Enforvers
	ZoneDetect:RegisterNPCID(80808, irondocks, 2) -- Grimrail Enforvers
	ZoneDetect:RegisterNPCID(79852, irondocks, 3) -- Oshir
	ZoneDetect:RegisterNPCID(83612, irondocks, 4) -- Skulloc
end

function Dungeons:OnEnable()
  self:RegisterExpansion("Myhtic+", "Myhtic+")
  self:RegisterRaidTier("Myhtic+", dungeonTierId, ("%s %s"):format("Myhtic+ ", "Season 4"), PLAYER_DIFFICULTY6.."+ 12/12",  PLAYER_DIFFICULTY6.."+ Casino")

  self:OperationMechagon()
  self:TazaveshtheVeiledMarket()
  self:ReturnToKarazhan()
  self:GrimrailDepot()
  self:IronDocks()

end
